<?php

/*
* Plugin Name: Blocked Content Countdown
* Description: Consigue mayor retención del usuario bloquea un contenido por un tiempo determinado
* Version: 1.1
* Author: Miquel Camps Orteza
* Author URI: https://vivirenremoto.com
*/


function secret_shortcode($atts=false, $content=false){
  if( $atts ) extract($atts);

  $id = mt_rand();

  if( !isset($seconds) ) $seconds = 30;

  if( !isset($encode) ) $encode = FALSE;

  $frase = get_option('blockedcontent_option_text');
  if( !$frase ) $frase = "<span style='font-size:40px'>🔒</span>\n<b>Contenido bloqueado</b>\nEste contenido estará visible en unos instantes";

  $css_box = get_option('blockedcontent_option_box');
  if( !$css_box ) $css_box = "border:2px red solid;\nborder-radius:15px;\npadding:15px;\ntext-align:center;";

  $frase = nl2br($frase);

  $box = '<style>#protected_' . $id . '{' . $css_box . '}</style>';

  $box .= '<div id="protected_' . $id . '">';

  $box .= $frase;

  $box .= '<br><span id="countdown_' . $id . '">&nbsp;</span>';
  $box .= '</div>';

  

  if( $encode ){
    $box .= '<div id="hidden_content_' . $id . '" style="display:none" data-encode="1">';
    $box .= base64_encode( $content );
  }else{
    $box .= '<div id="hidden_content_' . $id . '" style="display:none">';
    $box .= $content;
  }
  
  $box .= '</div>';

  $box .= '<script>';
  $box .= 'var seconds' . $id . '=' . $seconds . '; var timer' . $id . ' = setInterval(function(){ if(seconds' . $id . '== 0){ clearInterval(timer' . $id . '); document.getElementById("protected_' . $id . '").style.display="none"; var box_content = document.getElementById("hidden_content_' . $id . '"); box_content.style.display="block"; if( box_content.dataset.encode == 1 ){ box_content.innerHTML = decodeURIComponent(escape(window.atob(box_content.innerHTML))); } }else{ seconds' . $id . '--; document.getElementById("countdown_' . $id . '").innerHTML = new Date(seconds' . $id . ' * 1000).toISOString().substr(11, 8); }  }, 1000);';
  $box .= '</script>';
  
  return $box;
}

add_shortcode('secret', 'secret_shortcode');

//////////////////////////////////////


function blockedcontent_register_settings() {
   add_option( 'blockedcontent_option_text', '');
   add_option( 'blockedcontent_option_box', '');
   register_setting( 'blockedcontent_options_group', 'blockedcontent_option_text', 'blockedcontent_callback' );
   register_setting( 'blockedcontent_options_group', 'blockedcontent_option_box', 'blockedcontent_callback' );
}
add_action( 'admin_init', 'blockedcontent_register_settings' );


function blockedcontent_register_options_page() {
  add_options_page('Blocked Content Countdown', 'Blocked Content Countdown', 'manage_options', 'blockedcontent', 'blockedcontent_options_page');
}
add_action('admin_menu', 'blockedcontent_register_options_page');

function blockedcontent_options_page()
{

$frase = get_option('blockedcontent_option_text');
if( !$frase ) $frase = "<span style='font-size:40px'>🔒</span>\n<b>Contenido bloqueado</b>\nEste contenido estará visible en unos instantes";

$css_box = get_option('blockedcontent_option_box');
if( !$css_box ) $css_box = "border:2px red solid;\nborder-radius:15px;\npadding:15px;\ntext-align:center;";

?>


  <div class="notice notice-warning" style="margin:30px 0 30px 0">
    <p><a href="https://vivirenremoto.com/plugins-vip-wordpress/" target="_blank" style="color:black;font-weight:bold;text-decoration:none;">Descubre más plugins molones como este</p></a>
  </div>

  <div>
  <h2>Blocked Content Countdown</h2>
  <form method="post" action="options.php">
  <?php settings_fields( 'blockedcontent_options_group' ); ?>

  <table>


  <tr class="form-field">
    <th scope="row" valign="top">
        <label for="blockedcontent_option_text">Texto con la cuenta atrás</label>
    </th>
  <td>
    <?php wp_editor( $frase, "blockedcontent_option_text", array() ); ?>
  </td>
  </tr>


  <tr class="form-field">
    <th scope="row" valign="top">
        <label for="blockedcontent_option_box">CSS de la caja contenedora</label>
    </th>
  <td>
    <textarea name="blockedcontent_option_box" id="blockedcontent_option_box" rows="5" cols="50" class="large-text"><?php echo $css_box; ?></textarea>
  </td>
  </tr>

  
  </table>
  <?php  submit_button(); ?>
  </form>
  </div>
<?php
}